package com.changhong.epc.admin.controller.cost;

import com.changhong.epc.admin.service.cost.CostTypeTemplateService;
import com.changhong.epc.admin.service.cost.SuppStanderTemplateService;
import com.changhong.epc.bean.admin.CostGroupType;
import com.changhong.epc.bean.admin.CostTypeTemplate;
import com.changhong.epc.bean.admin.SuppStanderTemplate;
import com.changhong.epc.bean.admin.extend.CostTypeTemplateExtend;
import com.changhong.epc.bean.admin.extend.SuppStanderTemplateDto;
import com.changhong.epc.bean.admin.extend.SuppStanderTemplateExtend;
import com.changhong.epc.constter.admin.AdminUrlConst;
import com.iemsoft.framework.cloud.core.tools.JSONTool;
import com.iemsoft.framework.cloud.core.tools.ObjectUtil;
import org.apache.commons.lang3.math.NumberUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@RestController
public class CostTypeTemplateController implements AdminUrlConst {
	
	@Resource(name = "costTypeTemplateServiceImpl")
	private CostTypeTemplateService costTypeTemplateService;

	@Resource
	private SuppStanderTemplateService suppStanderTemplateService;

	/**
	 * @Author WangYX
	 * @Description 查询业务类型模板
	 * @Date 2019/4/1 1:14 PM
	 */
	@PostMapping(REST_ADMIN_GET_COSTTYPE_TEMPLATE)
	public CostTypeTemplateExtend getCostTypeTemplate(@RequestBody CostTypeTemplate costTypeTemplate){
		return costTypeTemplateService.getCostTypeTemplate(costTypeTemplate.getId());
	}

	/**
	 * 分页查询费用类型组所有信息
	 * 
	 */
	@PostMapping(REST_ADMIN_COSTTYPETEMPLATE_SELECT)
	public List<CostTypeTemplate> selectPage(@RequestBody CostTypeTemplate costTypeTemplate){
		return costTypeTemplateService.selectByPage(costTypeTemplate);
	}
	
	/**
	 * 添加费用组类型信息
	 * @return
	 */
	@PostMapping(REST_ADMIN_COSTTYPETEMPLATE_ADD)
	public CostTypeTemplate addCostType(@RequestBody CostTypeTemplate costTypeTemplate) {
		return costTypeTemplateService.addCostType(costTypeTemplate);
	}

	/**
	 * 删除费用组类型信息
	 * @return
	 */
	@PostMapping(REST_ADMIN_COSTTYPETEMPLATE_DELETE)
	public int deleteCostType(@RequestBody Map<String,Object> map) {
		return costTypeTemplateService.deleteCostType(
				JSONTool.toList(JSONTool.toJson(map.get("id")), String.class));
	}
	
	/**
	 * 修改费用组类型信息
	 * @return
	 */
	@PostMapping(REST_ADMIN_COSTTYPETEMPLATE_UPDATE)
	public int updateCostType(@RequestBody CostTypeTemplate costTypeTemplate) {
		return costTypeTemplateService.updateCostType(costTypeTemplate);
	}
	
	
	/**
	 * zz
	 * 验证模板名称是否存在
	 * 
	 */
	@PostMapping(SELECT_TEMPLATE_NAME_IS_EXIST)
	public int isExistence(@RequestBody Map<String , String > paramName){
		String name = paramName.get("name");
		List<CostTypeTemplate> list = costTypeTemplateService.getCostTypeTemplateByName(name);
		if(ObjectUtil.empty(list)){
			return 0;
		}else{
			return list.size();
		}
	}
	
	/**
	 * 新增模板及费用项
	 * zz
	 */
	@PostMapping(ADD_TEMPLATE_AND_COSTTYPE)
	public int addTemplate(@RequestBody CostTypeTemplateExtend costTypeTemplate){
//		String name = param.get("name");
//		String costDesc = param.get("costDesc");
//		CostTypeTemplate costTypeTemplate=new CostTypeTemplateExtend();
//		costTypeTemplate.setName(name);
//		costTypeTemplate.setCostDesc(costDesc);

//		List<CostGroupType> constGroupTypes=JSONTool.toList(param.get("constGroupTypes"), CostGroupType.class);
		return costTypeTemplateService.addTemplateAndCostType(costTypeTemplate, costTypeTemplate.getConstGroupTypes());
	}
	
	
	
	/**
	 * 通过模板查询费用项（非树）
	 * zz
	 */
	@PostMapping(SELECT_COSTTYPE_BY_TEM)
	public List<CostGroupType> selectCostTypeByTem(@RequestBody Map<String , String> param){
		return costTypeTemplateService.getCostTypeByTemId(NumberUtils.createInteger(param.get("id")));
	}

	@PostMapping(UPDATE_TEMPLATE)
	public int updateTemplateInfo(@RequestBody CostTypeTemplateExtend costTypeTemplate){
		return costTypeTemplateService.updateTemplateInfo(costTypeTemplate);
	}

	/**
	 * 修改模板及费用项
	 * zz
	 */
	@PostMapping(UPDATE_TEMPLATE_AND_COSTTYPE)
	public int updateTemplate(@RequestBody CostTypeTemplateExtend costTypeTemplate){
//		String id = param.get("id");
//		String name = param.get("name");
//		String costDesc = param.get("costDesc");
//		CostTypeTemplate costTypeTemplate=new CostTypeTemplate();
//		costTypeTemplate.setId(Integer.parseInt(id));
//		costTypeTemplate.setName(name);
//		costTypeTemplate.setCostDesc(costDesc);
//
//		List<CostGroupType> constGroupTypes=JSONTool.toList(param.get("constGroupTypes"), CostGroupType.class);
		return costTypeTemplateService.updateTemplateAndCostType(costTypeTemplate, costTypeTemplate.getConstGroupTypes());
		
	}

	@PostMapping(SAVE_SUPP_TEMPLATE)
	public int saveSupp(@RequestBody SuppStanderTemplateDto suppStander){
		return suppStanderTemplateService.saveSupp(suppStander);
	}

	/**
	 * 查询补助标准
	 */
	@PostMapping(SELECT_SUPP_TEMPLATE)
	public List<SuppStanderTemplateExtend> selectById(@RequestBody SuppStanderTemplate suppStander){
		return suppStanderTemplateService.selectByid(suppStander);
	}



}
