package com.changhong.epc.admin.controller.master;

import com.changhong.epc.admin.service.master.impl.MasterDefineServiceImpl;
import com.changhong.epc.bean.tenant.master.MasterDefine;
import com.changhong.epc.bean.tenant.master.extend.GeneralMasterValue;
import com.changhong.epc.bean.tenant.master.extend.MasterDefinesExtend;
import com.changhong.epc.bean.tenant.master.extend.MasterList;
import com.changhong.epc.bean.tenant.sunCloud.MasterFtp;
import com.changhong.epc.constter.admin.AdminUrlConst;
import com.changhong.epc.constter.base.BaseConst;
import com.changhong.epc.rely.api.tool.VersionFilterApi;
import com.iemsoft.framework.cloud.core.thread.ThreadData;
import com.iemsoft.framework.cloud.core.tools.JSONTool;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

@RestController
public class MasterDefineController implements AdminUrlConst {

    @Autowired
    private MasterDefineServiceImpl masterDefineService;

    /**
     * 查询主数据维度
     */
    @PostMapping(MASTER_SELECTBYQUERY)
    public List<MasterDefine> selectByQuery(@RequestBody MasterDefine masterDefine){
        // System.out.println("公司id:"+ThreadData.get(BaseConst.COMPANY_ID));
        // System.out.println("参数:"+ JSONTool.toJson(masterDefine));
        return masterDefineService.selectByQuery(masterDefine.getType());
    }

    /**
     * 查询所有主数据列表
     * @return
     */
    @PostMapping(MASTER_SELECTALLMASTER)
    public List<MasterDefine> selectAllMaster(@RequestBody MasterDefine map) {
        return masterDefineService.selectAllMaster(map);
    }

    /**
     * 查询所有主数据下所有元素
     */
    @PostMapping(MASTER_SELECTELE)
    public List<MasterDefinesExtend> selectEle(@RequestBody MasterDefine masterDefine){
        return masterDefineService.selectEle(masterDefine);
    }

    /**
     * 查询所有主数据下所有元素
     */
    @PostMapping(MASTER_SELECTNAME)
    public List<MasterDefinesExtend> selectName(@RequestBody MasterDefine masterDefine){
        return masterDefineService.selectName(masterDefine);
    }

    /**
     * 通用主数据全量拉取（定义，元素）
     */

    /**
     * 通用主数据全量拉取值（值）
     */

    
    /**
	 * 对外接口，ftp主数据
	 */ 
	@PostMapping(REST_ADMIN_JSON_ADDFTPPATH)
	public int addMasterFtp(@RequestParam("filePaths") String filePaths,@RequestParam("dataType")String dataType){
		MasterFtp ftp = new MasterFtp();
		ftp.setFilePaths(filePaths);
		ftp.setDataType(dataType);
		return masterDefineService.addMasterFtp(ftp);
	}

	/**
     * 更新数据MasterFtp
     * */
	@PostMapping(REST_ADMIN_JSON_UPDATEFTPPATH)
    public int updateMasterFtp(@RequestBody MasterFtp masterFtp){
	    return masterDefineService.updateMasterFtp(masterFtp);
    }

    /**
     * 查询数据
     * */
    @PostMapping(REST_ADMIN_JSON_FINDFTPPATH)
    public List<MasterFtp> findMasterFtp(){
       return masterDefineService.findMasterFtp();
    }


    /**
     * 增加，更新，删除三表数据
     * */
    @PostMapping(REST_ADMIN_ADDMASTERLIST)
    public int cudThreeTables(@RequestBody MasterList masterList){
        return masterDefineService.cudThreeTables(masterList);
    }

}
