package com.changhong.epc.admin.controller.master;

import com.changhong.epc.admin.service.master.impl.MasterElementServiceImpl;
import com.changhong.epc.bean.tenant.master.MasterAlias;
import com.changhong.epc.bean.tenant.master.MasterEleValue;
import com.changhong.epc.bean.tenant.master.MasterElement;
import com.changhong.epc.bean.tenant.master.MasterValue;
import com.changhong.epc.bean.tenant.master.extend.MasterElementExtend;
import com.changhong.epc.constter.admin.AdminUrlConst;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
public class MasterElementController implements AdminUrlConst {
	
	
	@Autowired
	private MasterElementServiceImpl masterElementService;
	
	/**
	 * 查询元素
	 */
	@PostMapping(ELEMENT_SELECTBYCODE)
	public List<MasterElementExtend> selectByCode(@RequestBody MasterElement masterElement){
		return masterElementService.selectByCode(masterElement.getDefineCode());
	}
	
	/**
	 * 递归查询所有关联Code
	 */
	@PostMapping(ELEMENT_SELECT)
	public List<MasterEleValue> select(@RequestBody MasterEleValue master){
		return masterElementService.selectCode(master);
	}
	
	/**
	 * 根据指定主数据定义查询元素
	 */
	@PostMapping(ELEMENT_ELEMENTINFOS)
	public List<MasterElement> elementInfos(@RequestBody MasterElement masterElement){
		return masterElementService.elementInfos(masterElement);
	}
	
	/**
	 * 批量查询关联主数据
	 */
	@PostMapping(ELEMENT_SELECTDEFINES)
	public List<MasterEleValue> selectDefines(@RequestBody List<MasterEleValue> master){
		return masterElementService.selectCodes(master);
	}

	/**
	 * 指定主数据code，name
	 *
	 */
	@PostMapping(ELEMENT_UPDATEALIAS)
	public int updateAlias(@RequestBody MasterAlias alias){
		return masterElementService.updateAlias(alias);
	}

	@PostMapping(ADMIN_DEFINE_CODE)
	public MasterElement geteleCode(@RequestBody MasterEleValue masterEleValue){
	    return masterElementService.geteleCode(masterEleValue.getDefineCode());
    }

	/**
	 * getval函数跨服务调用
	 */
	@PostMapping(MASTER_VALUE_GETVAL)
	public MasterValue getVal(@RequestBody MasterEleValue mv){
		MasterValue m = new MasterValue();
		m.setValue(masterElementService.getValFunc(mv));
		return m;
	}


}
