package com.changhong.epc.admin.controller.template;

import com.changhong.epc.admin.service.sysCost.SystemExtend;
import com.changhong.epc.bean.count.system.SystemMathExtend;
import com.changhong.epc.constter.base.BaseConst;
import com.changhong.epc.constter.system.run.EpcRestInterface;
import com.iemsoft.framework.cloud.core.thread.Keys;
import com.iemsoft.framework.cloud.core.thread.ThreadData;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

import static com.changhong.epc.constter.admin.AdminUrlConst.REST_TENANT_SYSTEMCONFIG_ADMIN_Cost_SELECTALL;
import static com.changhong.epc.constter.admin.AdminUrlConst.REST_TENANT_SYSTEMCONFIG_ADMIN_SELECTALL;

@RestController
public class SysCostController {

    @Autowired
    private SystemExtend systemExtend;

    @Value("${tenantId:100000023}")
    private String tenantId;

    @Value("${companyId:17}")
    private Integer companyId;


    /**
     * admin系统模板
     *
     * @param
     * @return
     */
    @PostMapping(path = REST_TENANT_SYSTEMCONFIG_ADMIN_SELECTALL)
    public List<SystemMathExtend> selectSys() {
        ThreadData.set(BaseConst.TENANT_ID, tenantId);
        ThreadData.set(BaseConst.COMPANY_ID,companyId);
        return systemExtend.getSystemExtend();

    }
    /**
     * adminCost费用
     *
     * @param
     * @return
     */
    @PostMapping(path = REST_TENANT_SYSTEMCONFIG_ADMIN_Cost_SELECTALL)
    public List<Map<String,String>> selectCost() {
        ThreadData.set(BaseConst.TENANT_ID, tenantId);
        ThreadData.set(BaseConst.COMPANY_ID,companyId);
        return systemExtend.getCost();

    }
}
