package com.changhong.epc.admin.mapper.centen.initguide;

import com.changhong.epc.bean.admin.CostGroupType;
import com.changhong.epc.bean.admin.InitCompany;
import com.changhong.epc.bean.tenant.system.permission.PowerKey;
import com.changhong.epc.rely.api.bean.Company;
import com.changhong.epc.rely.api.bean.TenantnameAndCompanyname;
import com.iemsoft.framework.cloud.mybatis.common.MybatisBaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;


/**
 *初始化向导使用
 *epc_init_company 
 * 
 */
public interface InitCompanyMapper extends MybatisBaseMapper<InitCompany> {
	
	/**
	 *判断公司是否初始化配置过 
	 */
	int isInitCompany(@Param("companyId")String companyId);
	
	/**
	 * 添加初始化的公司
	 */
	int addInitCompany(@Param("company")Company company,@Param("tableRule")PowerKey powerKey);
	
	/**
	 *通过费用项模板id获取其下的费用项 
	 */
	List<CostGroupType> getCostGroupType(@Param("id") int id);
	
	/**
	 *查询初始化过的公司 
	 */
	List<InitCompany> selectInitCompany(InitCompany initCompany);

    void initMenu(@Param("tenantId") Integer tenantId, @Param("companyId") Integer companyId);

    String selectInitCompanyId(@Param("tenantId") Integer tenantId);

    List<Map<String,String>> selectTenantnameAndCompanynameByid(@Param("tenantId") String tenantId, @Param("companyId") String companyId);
}
