package com.changhong.epc.admin.mapper.centen.master;

import com.changhong.epc.bean.admin.MasterElementMapping;
import com.changhong.epc.bean.count.MeInfo;
import com.changhong.epc.bean.tenant.master.CodeAndAlias;
import com.changhong.epc.bean.tenant.master.MasterEleValue;
import com.changhong.epc.bean.tenant.master.MasterElement;
import com.changhong.epc.bean.tenant.master.MasterValue;
import com.changhong.epc.bean.tenant.master.extend.GeneralMasterValue;
import com.changhong.epc.bean.tenant.master.extend.MasterValueListExtend;
import com.iemsoft.framework.cloud.mybatis.common.MybatisBaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface MasterValueMapper  extends MybatisBaseMapper<GeneralMasterValue>{
	
	int isEmpty(@Param("mdCode") String mdCode, @Param("eleCode") String eleCode, @Param("rowNo") int rowNo, @Param("tenantId") String tenantId);

	String getMasterValString(@Param("paramMap") Map<String, Object> paramMap);

	 int updateStart(@Param("mdCode") String mdCode, @Param("list") List<Map<String, Object>> dataList);

	int deleteValue(@Param("config") Map<String, Object> config, @Param("data") Map<String, Object> data);

	Object getVal(@Param("mast") MasterEleValue masterEleValue);

	MasterValueListExtend selectMasterValueListExtend(@Param("defineCode") String defineCode
            , @Param("params") List<CodeAndAlias> params, @Param("isAll") String isAll, @Param("list") List<String> codes, @Param("value") String value);

	List<MasterElement> selectCode(@Param("code") String defineCode);

	/**
	 * 查询主数据下所有值
	 */
	List<MasterValue> selectValue(@Param("code") String defineCode);


	/**
	 * 根据多条主数据 获得第一条返回结果  String类型
	 */
	String getValString(@Param("mdCode") String mdCode, @Param("meCode") String mecode
            , @Param("params") List params);


//	/**
//	 * @param tableName
//	 * @param list
//	 * @return
//	 */
	List<Map<String,String>> selectValues(@Param("name") String tableName, @Param("list")List<MasterElementMapping> list);

	int deleteAll();

	/**
	 * 查询主数据带搜索条件
	 */
	List<MasterValue> selectValueSeache(@Param("code") String defineCode, @Param("list") List<String> list, @Param("value") String value);

	/**
	 * 根据人员信息查询出人员code
	 */
	String getMasterCode(@Param("master") MasterValue masterValue);

	int deleteByDefineCode(@Param("code") String code,@Param("tableName") String tableName);

	/**
     * 根据id创建对应value表
     * */
	int createValueTable(@Param("tableName")String tableName,@Param("list")List<String> list);

	/**
     * 插入其他value表
     * @Param gmv
     * @Param tableName
     * */
	int insertOtherValue(@Param("valueListMap") Map<String,String> valueListMap,@Param("tableName")String tableName);

	int insert(@Param("val") GeneralMasterValue val);

	int addTabelColumns(@Param("tableName")String tableName,@Param("code") String code);

	int updateMasterVal(@Param("mv") GeneralMasterValue mv);

	int delMasterValue(@Param("mv") GeneralMasterValue mv);

	int updateOtherValue(@Param("mv") Map<String, String> mv,@Param("tableName")String tableName,
                         @Param("defineCode")String defineCode,@Param("rowNo")String rowNo);
	int deleteOtherValue(@Param("tableName")String tableName, @Param("defineCode")String defineCode,
                        @Param("rowNo")String rowNo);
	/**
	 * 根据行号查询value是否存在1维表
	 * */
	Integer selectByRowNo(@Param("no")Integer no,@Param("eleCode")String eleCode,@Param("defineCode") String code);

	/**
     * 根据行号查询2位表
     * */
	List<Map<String,Object>> selectTwoByRowNo(@Param("tableName")String name,@Param("no")String no);

	/**
	 * 查询主数据值
	 * @param record
	 * @return
	 */
	List<MasterValue> selectMasterValueList(MasterValue record);

	List<Map<String,String>> selectMaster2(@Param("name")String tableName,@Param("field") List<MasterElementMapping> field);

	/**
	 * 查询二维表
	 * @param defMapTableName
	 * @param defMapTalbeField
	 * @param params
	 * @return
	 */
    String getValTwoDimensional(@Param("tableName") String defMapTableName, @Param("resField") String defMapTalbeField, @Param("params") List<MeInfo> params);
    
    /**
     * 二维表codevalue转换
     */
    String twoCodeValue(@Param("field")String field
    		,@Param("tableName")String tableName
    			,@Param("conditionField")String conditionField,@Param("conditionValue")String conditionValue);

	List<Map<String,String>> seacherValues(@Param("code")String code
			,@Param("value")String value,@Param("tableName")String tableName
			,@Param("list") List<String> list,@Param("eleValue")String eleValue);
}
