package com.changhong.epc.admin.service.corres.impl;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.changhong.epc.admin.mapper.centen.corres.CorresElFieldMapper;
import com.changhong.epc.admin.service.corres.CorresElFieldService;
import com.changhong.epc.bean.admin.CorresElField;
import com.changhong.epc.bean.admin.extend.CorresElFieldExtendFind;
@Service("corresElFieldServiceImpl")
public class CorresElFieldServiceImpl implements CorresElFieldService {

	@Resource
	private CorresElFieldMapper corresElFieldMapper;
	
	
	
	/**
	 * 查询出所有常量,放入缓存
	 * @return
	 */
	@Override
	public CorresElFieldExtendFind selectAll() {
		CorresElFieldExtendFind corres = new CorresElFieldExtendFind();
		corres.setCorresElFieldList(corresElFieldMapper.selectAll());
		return corres;
	}
	
	/**
	 * 查询出所有data_start为0常量
	 * 
	 */
	@Override
	public List<CorresElField> findCorres(CorresElField corr) {
			
			return corresElFieldMapper.select(corr);
		}
	
	/**
	 * 修改常量
	 * @return
	 */
	@Override
	public int updateCorres(CorresElField corr) {
		
		return corresElFieldMapper.updateByPrimaryKey(corr);
	}


	/**
	 * 逻辑删除常量
	 * @return
	 */
	@Override
	public int deleteCorres(CorresElField corr) {
		
		return corresElFieldMapper.deleteCorres(corr);
	}

	/**
	 * 添加常量
	 * @return
	 */
	@Override
	public int addCorres(CorresElField corr) {
		corr.initParam();
		return corresElFieldMapper.insert(corr);
	}
	
	
	/**
	 * 通过常量获取mdcode
	 * @return
	 *//*
	@Override
	public String getMDCodeByBMCode(String bmCode) {
		try{
			String mbCode=null;
			List<String> mbCodes = corresElFieldMapper.getMdCode(bmCode);
			if(mbCodes!=null && mbCodes.size()>0){
				mbCode = mbCodes.get(0);
			}
			return mbCode;
		}catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}*/

	@Override
	public List<CorresElField> getCorresElField(CorresElField corr) {
		return corresElFieldMapper.getCorresElField(corr);
	}
	
	
}
