package com.changhong.epc.admin.service.cost;

import java.util.List;

import com.changhong.epc.bean.admin.CostGroupType;
import com.changhong.epc.bean.admin.CostTypeTemplate;
import com.changhong.epc.bean.admin.extend.CostGroupTypeExtend;
import com.changhong.epc.bean.admin.extend.CostTypeTemplateExtend;
import org.apache.ibatis.annotations.Param;


public interface CostTypeTemplateService {

	/**
	 * @Author WangYX
	 * @Description 查询业务类型模板
	 * @Date 2019/4/1 1:14 PM
	 */
	CostTypeTemplateExtend getCostTypeTemplate(Integer ctId);

	/**
	 * 查询所有费用类型组信息
	 * @return
	 */
	List<CostTypeTemplate> selectByPage(CostTypeTemplate costTypeTemplate);
	
	/**
	 * 修改费用组类型信息
	 * @return
	 */
	int updateCostType(CostTypeTemplate costTypeTemplate);
	
	/**
	 * 添加费用组类型信息
	 * @return
	 */
	CostTypeTemplate addCostType(CostTypeTemplate costTypeTemplate);
	
	/**
	 * 删除费用组类型信息
	 * @return
	 */
	int deleteCostType(List<String> costTypeTemplate);
	
	
	/**
	 *zz
	 *通过name查询费用类型模板 
	 * 
	 */
	List<CostTypeTemplate> getCostTypeTemplateByName(String name);
	
	/**
	 * 创建模板并添加费用项
	 */
	int addTemplateAndCostType(CostTypeTemplate costTypeTemplate,List<CostGroupTypeExtend> constGroupTypes);

	
	/**
	 * 修改费用项模板及费用类型
	 */
	int updateTemplateAndCostType(CostTypeTemplate costTypeTemplate,List<CostGroupTypeExtend> constGroupTypes);
	
	List<CostGroupType> getCostTypeByTemId(int id);

	int updateTemplateInfo(CostTypeTemplateExtend costTypeTemplate);
}
