package com.changhong.epc.admin.service.initguide;


import com.changhong.epc.bean.PageResult;
import com.changhong.epc.bean.admin.BatchInitCompany;
import com.changhong.epc.bean.admin.InitCompany;
import com.changhong.epc.bean.admin.InitPowerInfo;
import com.changhong.epc.rely.api.bean.Company;
import com.changhong.epc.rely.api.bean.Tenant;

import java.util.List;

public interface InitGuideService {
	PageResult<Tenant> getTenants(Tenant tenant);

	PageResult<Company> getCompanys(Company company);
	
	int doInit(List<Company> companys, int id, List<Tenant> tenants);

	/**
	 * 初始化租户、公司
	 * @param initCompany
	 * @return
	 */
	int initTenantCompany(InitCompany initCompany);

	/**
	 *查询初始化过的公司 
	 */
	List<InitCompany> getInitCompany(InitCompany initCompany);

	/**
	 * 添加公司权限信息
	 * @param initPowerInfo
	 * @return
	 */
	InitCompany addCompanyPowerInfo(InitPowerInfo initPowerInfo);

	/**
	 * @Author WangYX
	 * @Description 添加初始化租户公司
	 * @Date 2019/3/28 3:17 PM
	 */
    String initCompanys(List<BatchInitCompany> batchInitCompany, Integer costTypeTempId);

    /**
     * @Author WangYX
     * @Description 查询初始化租户公司进度
     * @Date 2019/3/28 3:17 PM
     */
    List<BatchInitCompany> selectInitCompanys(String groupId);

    /**
     * @Author WangYX
     * @Description 添加初始化公司
     * @Date 2019/4/1 1:28 PM
     */
	int addInitCompany(InitCompany initCompany);

    List<BatchInitCompany> selectBatchCompanys();

	int updateBatchCompanys(BatchInitCompany batchInitCompany);
}
